#include "log.h"
#include <stdio.h>

void log_tree(Aswm* aswm, Window window, int indent) {
	XWindowAttributes window_attributes;
	XGetWindowAttributes(aswm->display, window, &window_attributes);
	for(int i = 0; i < indent; i++)
		printf("  ");
	printf("%lu ", window);
	if(window == XDefaultRootWindow(aswm->display)) {
		printf("(X root) ");
	} else if (window == aswm->root_window) {
		printf("(ASWM root) ");
	} else if (window == aswm->current_desktop.root_window) {
		printf("(current workspace) ");
	} else if (window == aswm->current_desktop.tile_root) {
		printf("(tile root) ");
	} else if (window == aswm->current_desktop.stack_root) {
		printf("(stack root) ");
	}
	printf("at (%i, %i): %ix%i\n", window_attributes.x, window_attributes.y, window_attributes.width, window_attributes.height);
	
	Window root_window;
	Window parent_tile;
	Window* children;
	unsigned int children_count;
	XQueryTree(aswm->display, window, &root_window, &parent_tile, &children, &children_count);
	for(auto i = 0; i < children_count; i++)
		log_tree(aswm, children[i], indent+1);
	XFree(children);
}
